<template>
    <div>
        <el-card>
            <el-form :inline="true" :model="filterQuery" class="query-form" size="mini">
                <el-form-item class="query-form-item">
                    <el-input
                        v-model="filterQuery.name"
                        placeholder="业务类型"
                    ></el-input>
                </el-form-item>
                <el-form-item class="query-form-item">
                    <el-select v-model="filterQuery.mainAction" placeholder="出入库类型">
                        <el-option label="全部" value=""></el-option>
                        <el-option label="入库" value="WareHouseIn"></el-option>
                        <el-option label="出库" value="WareHouseOut"></el-option>
                    </el-select>
                </el-form-item>
                <el-form-item class="query-form-item">
                    <el-select v-model="filterQuery.enabled" placeholder="是否启用">
                        <el-option label="全部" value=""></el-option>
                        <el-option label="已启用" value=1></el-option>
                        <el-option label="未启用" value=0></el-option>
                    </el-select>
                </el-form-item>
                <el-form-item>
                    <el-button-group style="margin-left: 10px;display:flex;">
                        <el-button type="primary" icon="el-icon-refresh" @click="onReset"></el-button>
                        <el-button type="primary" icon="search" @click="search">查询</el-button>
                        <el-button type="primary" icon="search" @click="handleAddClick"
                                   :disabled="!configParms.typeScan"
                        >新增
                        </el-button
                        >
                        <el-button type="primary" icon="search" @click="exportJsonFile">导出单据类型</el-button>
                        <el-upload
                            :action="uploadFileUrl"
                            multiple
                            :limit="3"
                            :headers="headers"
                            :show-file-list="false"
                            :on-success="handleChange"
                            :file-list="fileList"
                        >
                            <el-button size="mini" type="primary">导入单据类型</el-button>
                        </el-upload>


                    </el-button-group>

                </el-form-item>
            </el-form>

            <el-table v-loading="loading" :data="list" style="width: 100%">
                <el-table-column label="序号" type="index" width="60" fixed></el-table-column>
                <el-table-column label="扫码单据类型" prop="name" fixed></el-table-column>
                <el-table-column label="出入库类型" prop="mainAction" fixed>
                    <template slot-scope="scope">
                        <span>{{ mainActionMap[scope.row.mainAction] }}</span>
                    </template>
                </el-table-column>
                <!--        <el-table-column label="扫码单据类型代码" prop="action" fixed></el-table-column>-->
                <el-table-column label="是否启用" prop="enable" fixed>
                    <template slot-scope="scope">
                        <span>{{ enableMap[scope.row.enable] }}</span>
                    </template>
                </el-table-column>
                <el-table-column label="必须选择业务单据校验" prop="checkEnable" fixed>
                    <template slot-scope="scope">
                        <span>{{ enableMap[scope.row.checkEnable] }}</span>
                    </template>
                </el-table-column>
                <el-table-column label="二次核对" prop="secCheckEnable" fixed>
                    <template slot-scope="scope">
                        <span>{{ enableMap[scope.row.secCheckEnable] }}</span>
                    </template>
                </el-table-column>
                <el-table-column label="关联业务单据" prop="localName" fixed></el-table-column>


                <el-table-column label="操作" fixed="right">
                    <template slot-scope="scope">
                        <el-button
                            type="text"
                            size="small"
                            @click.native.stop="handleModifyClick(scope.row)"
                        >编辑
                        </el-button
                        >
                        <el-button
                            type="text"
                            size="small"
                            :disabled="!configParms.typeScan"
                            @click.native.stop="deleteDialog(scope.row)"
                        >删除
                        </el-button
                        >
                    </template>

                </el-table-column>
            </el-table>

            <el-dialog
                title="新增扫码单据类型"
                :visible.sync="addDialogVisible"
                width="70%"
                :close-on-click-modal="false"
                :close-on-press-escape="false"
                v-if="addDialogVisible"
            >
                <modifyDialog :inputQuery="inputQuery"></modifyDialog>
                <div style="text-align: center">
                    <el-button type="primary" size="small" icon="search" @click="onAddSubmit"
                               :disabled="!configParms.typeScan"
                    >提交
                    </el-button
                    >
                    <el-button type="primary" size="small" icon="search" @click="cancelDialog"
                    >取消
                    </el-button
                    >
                </div>
            </el-dialog>

            <el-dialog
                title="编辑扫码单据类型"
                :visible.sync="modifyDialogVisible"
                width="70%"
                :close-on-click-modal="false"
                :close-on-press-escape="false"
                v-if="modifyDialogVisible"
            >
                <modifyDialog :inputQuery="inputQuery"></modifyDialog>
                <div style="text-align: center">
                    <el-button type="primary" size="small" icon="search" @click="onModifySubmit"
                               :disabled="!configParms.typeScan"
                    >提交
                    </el-button
                    >
                    <el-button type="primary" size="small" icon="search" @click="cancelDialog"
                    >取消
                    </el-button
                    >
                </div>
            </el-dialog>
            <el-pagination
                :page-size="filterQuery.limit"
                @current-change="handleCurrentChange"
                layout="prev, pager, next"
                :total="total"
                :current-page="filterQuery.page"
            ></el-pagination>
        </el-card>
    </div>
</template>
<script>
import {
    getJoinBussinessType,
    deleteBussinessType,
    updateBussinessType,
    insertBussinessType, exportFile,
} from "../../api/basic/bussinessType";

import modifyDialog from "./BussinessTypeModify";
import axios from "axios";
import store from "@/store";
import {getLocalJoinBusType} from "@/api/basic/busLocalType";
import {findConfig} from "@/api/thrsys/spsSyncStatus";
import {isBlank} from "@/utils/strUtil";

export default {
    data() {
        return {
            filterQuery: {
                enabled: "1",
                udiwmsType: "",
                thirdType: "",
                page: 1,
                limit: 20,
            },
            addDialogVisible: false,
            modifyDialogVisible: false,
            list: [],
            inputQuery: {
                action: "",
                name: "",
                enable: null,
                remark: "",
                mainAction: "",
                thirdSysFk: "",
                id: "",
                localAction: null,
                checkEnable: false,
                genUnit: false,
                innerOrder: false,
                spUse: null,
                secCheckEnable: null,
                checkUdims: null,
                checkPdaEd: null,
                checkPdaUn: null,
                checkPc: null,
                checkWebNew: null,
                checkChange: null,
                checkCopy: null,
                secCheckUdims: null,
                secCheckPdaEd: null,
                secCheckPdaUn: null,
                secCheckPc: null,
                secCheckWebNew: null,
                secCheckChange: null,
                thirdAction: null,
                secCheckSp: null,
                checkSp: null,
                checkBalacne: null,
                secCheckBalacne: null,
                secCheckCopy: null,
                corpType: null,
                storageCode: null,
                supplementOrderType: null,
                defaultUnit: null,
                useDyCount: null,
                expireTip: true,
                prefix: null,
                outTospms: null,
                ullageFill: null,
                scanPreIn: null,
                vailInv: null,
                entrutSpms: null,
                codeFillCheck: null,
                defaultInv: null,
                defaultSubInv: null,
                orderVisibleType: 0,
            },
            enableMap: {
                true: "是",
                false: "否",
            },
            mainActionMap: {
                WareHouseIn: "入库",
                WareHouseOut: "出库"
            },
            fileList: [],
            total: 0,
            multipleSelection: [],
            uploadFileUrl: null,
            headers: {},
            configParms: {},
            loading: false,

        };
    },

    methods: {
        onReset() {
            this.$router.push({
                path: "",
            });
            this.filterQuery = {
                enable: null,
                udiwmsType: "",
                thirdType: "",
                page: 1,
                limit: 20,
            };
            this.getList();
        },
        cancelDialog() {
            this.modifyDialogVisible = false;
            this.addDialogVisible = false;
        },
        search() {
            this.filterQuery.page = 1;
            this.getList();
        },
        getList() {
            this.loading = true;
            getJoinBussinessType(this.filterQuery)
                .then((response) => {
                    this.loading = false;
                    this.list = response.data.list || [];
                    this.total = response.data.total || 0;
                })
                .catch(() => {
                    this.loading = false;
                    this.list = [];
                    this.total = 0;
                });
        },
        handleCurrentChange(val) {
            this.filterQuery.page = val;
            this.getList();
        },

        onAddSubmit() {
            if (isBlank(this.inputQuery.name)) {
                this.$message.error("扫码单据类型名称不能为空！");
                return;
            }
            if (this.$isBlank(this.inputQuery.corpType)) {
                this.$message.error("往来信息类型不能为空！");
                return;
            }
            if (this.inputQuery.enable && this.inputQuery.localAction == "") {
                this.$message.error("本地单据类型不能为空！");
                return;
            }
            if (this.inputQuery.mainAction == "" || this.inputQuery.mainAction == null) {
                this.$message.error("出入库类型不能为空！");
                return;
            }
            insertBussinessType(this.inputQuery)
                .then((response) => {
                    if (response.code == 20000) {
                        this.loading = false;
                        this.cancelDialog();
                        this.getList();
                    } else {
                        this.$message.error(response.message);
                    }
                })
                .catch(() => {
                    this.loading = false;
                    this.cancelDialog();
                });
        },

        onModifySubmit() {
            if (this.inputQuery.enable && this.inputQuery.localAction == "") {
                this.$message.error("本地单据类型不能为空！");
                return;
            }

            if (this.inputQuery.mainAction == "" || this.inputQuery.mainAction == null) {
                this.$message.error("出入库类型不能为空！");
                return;
            }
            updateBussinessType(this.inputQuery)
                .then((response) => {
                    if (response.code == 20000) {
                        this.loading = false;
                        this.cancelDialog();
                        this.getList();
                    } else {
                        this.$message.error(response.message);
                    }
                })
                .catch(() => {
                    this.loading = false;
                    this.cancelDialog();
                });
        },
        exportJsonFile() {
            exportFile().then((response) => {
                const binaryData = [];
                binaryData.push(response);
                let url = window.URL.createObjectURL(
                    new Blob(binaryData, {type: "application/json"})
                );
                this.loading = false;
                const eleLink = document.createElement('a');
                // var timestamp = "yyyy-MM-dd_hh:mm";
                eleLink.download = "扫码单据类型导出" + ".json";
                eleLink.style.display = 'none';
                eleLink.href = url;
                document.body.appendChild(eleLink)
                eleLink.click()
                document.body.removeChild(eleLink)
            }).catch(() => {
                this.loading = false;
            });
        },


        handleAddClick() {
            this.inputQuery = {enable: false, expireTip: true};
            this.addDialogVisible = true;
        },

        handleModifyClick(row) {
            this.inputQuery = {
                id: row.id,
                remark: row.remark,
                action: row.action,
                name: row.name,
                enable: row.enable,
                mainAction: row.mainAction,
                localAction: row.localAction,
                thirdSysFk: row.thirdSysFk,
                checkEnable: row.checkEnable,
                genUnit: row.genUnit,
                innerOrder: row.innerOrder,
                spUse: row.spUse,
                secCheckEnable: row.secCheckEnable,
                checkUdims: row.checkUdims,
                checkPdaEd: row.checkPdaEd,
                checkPdaUn: row.checkPdaUn,
                checkPc: row.checkPc,
                checkWebNew: row.checkWebNew,
                checkChange: row.checkChange,
                secCheckUdims: row.secCheckUdims,
                secCheckPdaEd: row.secCheckPdaEd,
                secCheckPdaUn: row.secCheckPdaUn,
                secCheckPc: row.secCheckPc,
                secCheckWebNew: row.secCheckWebNew,
                secCheckChange: row.secCheckChange,
                thirdAction: row.thirdAction,
                corpType: row.corpType + "",
                storageCode: row.storageCode,
                secCheckSp: row.secCheckSp,
                checkSp: row.checkSp,
                supplementOrderType: row.supplementOrderType,
                checkBalacne: row.checkBalacne,
                secCheckBalacne: row.secCheckBalacne,
                defaultUnit: row.defaultUnit,
                useDyCount: row.useDyCount,
                expireTip: row.expireTip,
                prefix: row.prefix,
                outTospms: row.outTospms,
                ullageFill: row.ullageFill,
                scanPreIn: row.scanPreIn,
                vailInv: row.vailInv,
                entrutSpms: row.entrutSpms,
                codeFillCheck: row.codeFillCheck,
                changeEnable: row.changeEnable,
                defaultSubInv: row.defaultSubInv,
                defaultInv: row.defaultInv,
                orderVisibleType: row.orderVisibleType,
                checkCopy: row.checkCopy,
                secCheckCopy: row.secCheckCopy,

            };
            this.modifyDialogVisible = true;
        },

        deleteDialog(rowId) {
            this.$confirm("此操作将永久删除该扫码类型信息, 是否继续?", "提示", {
                confirmButtonText: "确定",
                cancelButtonText: "取消",
                type: "warning",
            })
                .then(() => {
                    this.deleteOrders(rowId);
                })
                .catch(() => {
                });
        },


        getActionName(action) {
            for (let i = 0; i < this.busTypes.length; i++) {
                if (this.busTypes[i].localAction === action) {
                    return this.busTypes[i].localName;
                }
            }
        },
        getBusType() {
            let query = {
                enabled: true,
            };
            getLocalJoinBusType(query)
                .then((response) => {
                    this.busTypes = response.data.list || [];

                    this.getList();
                })
                .catch(() => {
                });
        },

        deleteOrders(data) {
            this.loading = true;
            let tquery = {
                id: data.id + "",
            };

            deleteBussinessType(tquery)
                .then((response) => {
                    this.getList();
                    if (response.code == 20000) {
                        this.$message({
                            type: "success",
                            message: "删除成功！",
                        });
                    } else {
                        this.$message.error(response.message);
                    }

                })
                .catch(() => {
                });
        },
        handleChange(response, files, fileList) {
            if (response.code != 20000) {
                this.$message.error(response.message);
            } else {
                this.$message.success(response.data);
                this.getList();
            }
        },
        init() {
            axios.get("./config.json").then(res => {
                // 基础地址
                let response = res.data.BASE_URL;
                this.uploadFileUrl = response + "/udiwms/busstiness/file/upload";
            });
            this.headers = {
                ADMIN_ID: store.getters.adminId,
                ADMIN_TOKEN: store.getters.token,
            };
        },
        getSyncConfig() {
            findConfig()
                .then((response) => {
                    if (response.code == 20000) {
                        this.configParms = response.data;
                    }
                })
                .catch(() => {
                });
        },
    },
    components: {
        modifyDialog,
    },
    mounted() {
    },
    created() {
        this.init();
        this.getSyncConfig();
        this.getList();
    },
};
</script>
